// CDGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "CDGeneral.h"
#include "..\UpDownClient.h"
#include "..\Server.h"
#include "..\emule.h"


// CCDGeneral dialog

IMPLEMENT_DYNCREATE(CCDGeneral, CPropertyPage)

CCDGeneral::CCDGeneral() : CPropertyPage(CCDGeneral::IDD)
{
	//{{AFX_DATA_INIT(CCDGeneral)
	//}}AFX_DATA_INIT

	m_hClientIcon = NULL;
}

CCDGeneral::~CCDGeneral()
{
	if(m_hClientIcon != NULL)
	{
		::DestroyIcon(m_hClientIcon);
	}
}

void CCDGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCDGeneral)
	DDX_Control(pDX, IDC_USERNAME_VAL, m_ctrlUserName);
	DDX_Control(pDX, IDC_USERHASH_VAL, m_ctrlUserHash);
	DDX_Control(pDX, IDC_SERVERNAME_VAL, m_ctrlServerName);
	DDX_Control(pDX, IDC_SERVERIP_VAL, m_ctrlServerIP);
	DDX_Control(pDX, IDC_IPADDRESS_VAL, m_ctrlClientIP);
	DDX_Control(pDX, IDC_ID_VAL, m_ctrlClientID);
	DDX_Control(pDX, IDC_CLIENTVERSION_VAL, m_ctrlClientVersion);
	DDX_Control(pDX, IDC_CLIENTSOFTWARE_VAL, m_ctrlClientSoftware);
	DDX_Control(pDX, IDC_CLIENTICON, m_ctrlClientIcon);
	DDX_Control(pDX, IDC_IDENTIFICATION_VAL, m_ctrlIdentification);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCDGeneral, CPropertyPage)
	//{{AFX_MSG_MAP(CCDGeneral)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CCDGeneral message handlers

BOOL CCDGeneral::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	
	Localize();
	Update();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CCDGeneral::Update()
{
	EMULE_TRY

	if(m_pClient == NULL)
		return;

	if(!::IsWindow(GetSafeHwnd()))
		return;

	HICON hClientIcon;
	HINSTANCE hInst = AfxGetInstanceHandle();
	switch(m_pClient->GetClientSoft()) 
	{
		case SO_CDONKEY:
			hClientIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_CDONKEY));
			break;
		case SO_LMULE:
			hClientIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_LMULE));			
			break;
		case SO_SHAREAZA:
			hClientIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_SHAREAZA));			
			break;
		case SO_EDONKEYHYBRID:
			hClientIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_EDONKEYHYBRID));			
			break;
		case SO_MLDONKEY:
			hClientIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_MLDONKEY));
			break;
		case SO_EMULE:
		case SO_OLDEMULE:
			if(m_pClient->m_pCredits->GetCurrentIdentState(m_pClient->GetIP()) != IS_IDENTIFIED)
			{
				hClientIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_SECUREHASH));
			}
			else
			{
				hClientIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_COMPROT));
			}
			break;
		case SO_EDONKEY:
			hClientIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_NORMAL));			
			break;
		default:
			hClientIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_UNKNOWN));			
			break;
	}

	if(m_hClientIcon != hClientIcon)
	{
		if(m_hClientIcon != NULL)
		{
			::DestroyIcon(m_hClientIcon);
		}
		m_hClientIcon = hClientIcon;

		m_ctrlClientIcon.SetIcon(m_hClientIcon);
	}
	else
	{
		if(hClientIcon != NULL)
		{
			::DestroyIcon(hClientIcon);
		}
	}

/*	// Display any Extra Overlay icons
	if (bIsBanned) //katsyonak 07/07/03
			m_imageList.Draw(dc, DL_ICON_BANNED_ONLY, point2, ILD_TRANSPARENT);
	else if (bIsFriend)
			m_imageList.Draw(dc, DL_ICON_FRIEND_ONLY, point2, ILD_TRANSPARENT);
	else if (fRemoteBaseModifier >= 1.1)
			m_imageList.Draw(dc, DL_ICON_CREDIT_DOWNESTIMATED, point2, ILD_TRANSPARENT);
*/

	CString strBuffer;
	strBuffer = m_pClient->GetUserName();
	if(!strBuffer.IsEmpty())
	{	
		m_ctrlUserName.SetWindowText(strBuffer);
	}
	else
	{	
		m_ctrlUserName.SetWindowText(_T("?"));
	}
	
	bool bLoadedSourceName = false ;
	if(m_pClient->GetUserName())
	{
		bLoadedSourceName = (_tcsstr(m_pClient->GetUserName(), ::GetResString(IDS_LOADEDSOURCE)) != NULL) || 
							(_tcsstr(m_pClient->GetUserName(), ::GetResString(IDS_EXCHANGEDSOURCE)) != NULL) ;
	}

	if(m_pClient->HasValidHash() && !bLoadedSourceName)
	{		
		strBuffer = "";
		CString strBuffer2;
		for(UINT i = 0; i < 16; i++)
		{
			strBuffer2.Format(_T("%02X"), m_pClient->GetUserHash()[i]);
			strBuffer += strBuffer2;
		}
		m_ctrlUserHash.SetWindowText(strBuffer);
	}
	else
	{	
		m_ctrlUserHash.SetWindowText(_T("?"));
	}

	bool bIsPlus = m_pClient->GetPlusVersion() && m_pClient->GetPlusVersion() < 0x2600;
	if(bIsPlus)
	{	
		m_ctrlClientSoftware.SetWindowText(::GetClientNameString(m_pClient->GetClientSoft()) + 
											_T(" ") + 
											::GetClientNameAndVersionString(m_pClient));
	}
	else
	{	
		m_ctrlClientSoftware.SetWindowText(::GetClientNameString(m_pClient->GetClientSoft()));
	}
	
	switch(m_pClient->GetClientSoft())
	{
		case SO_EMULE:
		case SO_LMULE:
		case SO_OLDEMULE:
		case SO_CDONKEY:
		case SO_SHAREAZA:
		{	
			strBuffer.Format(_T("v%s"), ::GetClientVersionString(m_pClient->GetClientSoft(),
								m_pClient->GetMuleVersion()));
			break;
		}
		case SO_UNKNOWN:
		{	
			strBuffer.Format(_T("???"));
			break;
		}
		default:
		{	
			strBuffer.Format(_T("v%s"), ::GetClientVersionString(m_pClient->GetClientSoft(),
								m_pClient->GetVersion()));
			break;
		}
	}
	
	if(!m_pClient->GetModVersion().IsEmpty() && !bIsPlus)
	{
		strBuffer += _T(" [");
		strBuffer += m_pClient->GetModVersion();
		strBuffer += _T("]");
	}
	m_ctrlClientVersion.SetWindowText(strBuffer);	

	strBuffer.Format(_T("%u (%s)"), m_pClient->GetUserID(), m_pClient->HasLowID() ? 
						::GetResString(IDS_PRIOLOW) : ::GetResString(IDS_PRIOHIGH));
	m_ctrlClientID.SetWindowText(strBuffer);
		
	strBuffer.Format(_T("%s:%i"), m_pClient->GetFullIP(), m_pClient->GetUserPort());
	m_ctrlClientIP.SetWindowText(strBuffer);
	
	if(m_pClient->GetServerIP())
	{
		CString strPort;
		in_addr server;
		server.S_un.S_addr = m_pClient->GetServerIP();
		strBuffer.Format(_T("%s"), inet_ntoa(server));
		strPort.Format(":%i", m_pClient->GetServerPort());
		m_ctrlServerIP.SetWindowText(strBuffer + strPort);
				
		CServer* pServer = g_eMuleApp.m_pServerList->GetServerByAddress(strBuffer, m_pClient->GetServerPort()); 
		if(pServer)
		{
			m_ctrlServerName.SetWindowText(pServer->GetListName());
		}
		else
		{
			m_ctrlServerName.SetWindowText(_T("?"));
		}
	}
	else
	{
		m_ctrlServerName.SetWindowText(_T("?"));
		m_ctrlServerName.SetWindowText(_T("?"));
	}

	if(m_pClient->Credits())
	{
		if(g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		{
			switch(m_pClient->Credits()->GetCurrentIdentState(m_pClient->GetIP()))
			{
				case IS_NOTAVAILABLE:
				{	
					m_ctrlIdentification.SetWindowText(::GetResString(IDS_IDENTNOSUPPORT));
					break;
				}
				case IS_IDFAILED:
				case IS_IDNEEDED:
				case IS_IDBADGUY:
				{	
					m_ctrlIdentification.SetWindowText(::GetResString(IDS_IDENTFAILED));
					break;
				}
				case IS_IDENTIFIED:
				{	
					m_ctrlIdentification.SetWindowText(::GetResString(IDS_IDENTOK));
					break;
				}
			}
		}
		else
		{	
			m_ctrlIdentification.SetWindowText(::GetResString(IDS_IDENTNOSUPPORT));
		}
	}
	else
	{		
		m_ctrlIdentification.SetWindowText(_T("?"));
	}

	EMULE_CATCH
}

void CCDGeneral::Localize(void)
{
	EMULE_TRY

	if(GetSafeHwnd())
	{
		GetDlgItem(IDC_USERHASH_LBL)->SetWindowText(GetResString(IDS_CD_UHASH));
		GetDlgItem(IDC_IDENTIFICATION_LBL)->SetWindowText(GetResString(IDS_CD_IDENT));
		GetDlgItem(IDC_CLIENTSOFTWARE_LBL)->SetWindowText(GetResString(IDS_CD_CSOFT));
		GetDlgItem(IDC_CLIENTVERSION_LBL)->SetWindowText(GetResString(IDS_CD_VERSION));
		GetDlgItem(IDC_CDG_IPADDRESS_LBL)->SetWindowText(GetResString(IDS_CD_UIP));
		GetDlgItem(IDC_ID_LBL)->SetWindowText(GetResString(IDS_CD_UID));
		GetDlgItem(IDC_SERVERNAME_LBL)->SetWindowText(GetResString(IDS_CD_SNAME));
		GetDlgItem(IDC_SERVERIP_LBL)->SetWindowText(GetResString(IDS_CD_SIP));
	}

	EMULE_CATCH
}
