// ClientDetails.cpp : implementation file
//

#include "stdafx.h"
#include "ClientDetails.h"
#include "..\UpDownClient.h"
#include ".\clientdetails.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClientDetails

IMPLEMENT_DYNAMIC(CClientDetails, CPropertySheet)

CClientDetails::CClientDetails(UINT nIDCaption, CUpDownClient* pClient, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	Init(pClient);
}

CClientDetails::CClientDetails(LPCTSTR pszCaption, CUpDownClient* pClient, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	Init(pClient);
}

CClientDetails::~CClientDetails()
{
}


BEGIN_MESSAGE_MAP(CClientDetails, CPropertySheet)
	//{{AFX_MSG_MAP(CClientDetails)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClientDetails message handlers

void CClientDetails::Init(CUpDownClient* pClient)
{
	m_pClient = pClient;
	m_nTimer = 0;
	
	m_proppageGeneral.m_pClient = m_pClient;
	m_wndTransfer.m_pClient = m_pClient;
	m_wndScores.m_pClient = m_pClient;

	m_strGeneralTitle.Format("%s", GetResString(IDS_PW_GENERAL));
	m_proppageGeneral.m_psp.dwFlags |= PSP_USETITLE;
	m_proppageGeneral.m_pPSP->pszTitle = m_strGeneralTitle;

	m_strTransferTitle.Format("%s", GetResString(IDS_INFLST_USER_TRANSFER));
	m_wndTransfer.m_psp.dwFlags |= PSP_USETITLE;
	m_wndTransfer.m_pPSP->pszTitle = m_strTransferTitle;

	m_strScoresTitle.Format("%s", GetResString(IDS_CD_SCORES));
	m_wndScores.m_psp.dwFlags |= PSP_USETITLE;
	m_wndScores.m_pPSP->pszTitle = m_strScoresTitle;

	AddPage(&m_proppageGeneral);
	AddPage(&m_wndTransfer);
	AddPage(&m_wndScores);
}

void CClientDetails::Localize(void)
{
	m_proppageGeneral.Localize();
	m_wndTransfer.Localize();
	m_wndScores.Localize();
}

void CClientDetails::Update()
{
	m_proppageGeneral.Update();
	m_wndTransfer.Update();
	m_wndScores.Update();
}

BOOL CClientDetails::OnInitDialog()
{
	BOOL bResult = CPropertySheet::OnInitDialog();

	Localize();
	m_nTimer = SetTimer(301, 10000, 0);

	return bResult;
}

void CClientDetails::OnTimer(UINT nIDEvent)
{
	if(nIDEvent == m_nTimer)
	{
		Update();
	}

	CPropertySheet::OnTimer(nIDEvent);
}
