// PPGproxy.cpp : implementation file
//

#include "stdafx.h"
#include "eMule.h"
#include "PPGProxy.h"
#include "opcodes.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CPPGProxy dialog

IMPLEMENT_DYNAMIC(CPPgProxy, CPropertyPage)
CPPgProxy::CPPgProxy()
	: CPropertyPage(CPPgProxy::IDD)
	, enableProxy(FALSE)
	, enableAuth(FALSE)
	, proxyPort(_T(""))
	, proxyUser(_T(""))
	, proxyPassword(_T(""))
	, proxyName(_T(""))
	, serverConWoProxy(FALSE)
	, proxyTypeDesc(_T(""))
	, proxyNameDesc(_T(""))
	, proxyPortDesc(_T(""))
	, userNameDesc(_T(""))
	, passwordDesc(_T(""))
	, authDesc(_T(""))
{
}

CPPgProxy::~CPPgProxy()
{
}

void CPPgProxy::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ENABLEPROXY, enableProxyCheck);
	DDX_Control(pDX, IDC_ENABLEAUTH, enableAuthCheck);
	DDX_Control(pDX, IDC_SERVERCON_WO_PROXY, serverConWoProxyCheck);
	DDX_Control(pDX, IDC_PROXYTYPE, proxyTypeCombo);
	DDX_Control(pDX, IDC_PROXYNAME, proxyNameEdit);
	DDX_Control(pDX, IDC_PROXYPORT, proxyPortEdit);
	DDX_Control(pDX, IDC_USERNAME, userNameEdit);
	DDX_Control(pDX, IDC_PASSWORD, passwordEdit);
	DDX_Check(pDX, IDC_ENABLEPROXY, enableProxy);
	DDX_Check(pDX, IDC_ENABLEAUTH, enableAuth);
	DDX_Text(pDX, IDC_PROXYPORT, proxyPort);
	DDX_Text(pDX, IDC_USERNAME, proxyUser);
	DDX_Text(pDX, IDC_PASSWORD, proxyPassword);
	DDX_Text(pDX, IDC_PROXYNAME, proxyName);
	DDX_Check(pDX, IDC_SERVERCON_WO_PROXY, serverConWoProxy);
	DDX_Text(pDX, IDC_PROXYTYPE_LBL, proxyTypeDesc);
	DDX_Text(pDX, IDC_PROXYNAME_LBL, proxyNameDesc);
	DDX_Text(pDX, IDC_PROXYPORT_LBL, proxyPortDesc);
	DDX_Text(pDX, IDC_USERNAME_LBL, userNameDesc);
	DDX_Text(pDX, IDC_PASSWORD_LBL, passwordDesc);
	DDX_Text(pDX, IDC_AUTH_LBL, authDesc);
}


BEGIN_MESSAGE_MAP(CPPgProxy, CPropertyPage)
	ON_BN_CLICKED(IDC_ENABLEPROXY, OnBnClickedEnableproxy)
	ON_BN_CLICKED(IDC_ENABLEAUTH, OnBnClickedEnableauth)
	ON_CBN_SELCHANGE(IDC_PROXYTYPE, OnCbnSelchangeProxytype)
	ON_EN_CHANGE(IDC_PROXYNAME, OnEnChangeProxyname)
	ON_EN_CHANGE(IDC_PROXYPORT, OnEnChangeProxyport)
	ON_EN_CHANGE(IDC_USERNAME, OnEnChangeUsername)
	ON_EN_CHANGE(IDC_PASSWORD, OnEnChangePassword)
	ON_BN_CLICKED(IDC_SERVERCON_WO_PROXY, OnBnClickedAscwop)
END_MESSAGE_MAP()


BOOL CPPgProxy::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	proxy = m_pPrefs->GetProxy();
	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPPgProxy::OnApply()
{
	UpdateData(TRUE);

	g_eMuleApp.m_pGlobPrefs->SetProxyASCWOP(serverConWoProxy);
	proxy.m_bUseProxy = enableProxy;
	proxy.m_bEnablePassword = enableAuth;
	proxy.m_nType = proxyTypeCombo.GetCurSel();
	
	proxy.m_strName = proxyName;
	if (proxyName.IsEmpty())
		proxy.m_bUseProxy = false;

	if (proxyPort.IsEmpty())
		proxy.m_uPort = 1080;
	else {
		proxy.m_uPort = _tstoi(proxyPort);
		if (proxy.m_uPort == 0)
			proxy.m_uPort = 1080;
	}
	
	proxy.m_strUser = proxyUser;
	if (proxyUser.IsEmpty())
		proxy.m_bEnablePassword = false;
		
	proxy.m_strPassword = Crypt(proxyPassword);
	if (proxyPassword.IsEmpty())
		proxy.m_bEnablePassword = false;
	
	m_pPrefs->SetProxySettings(proxy);
	LoadSettings();
	return TRUE;
}
// CPPGProxy message handlers

void CPPgProxy::OnBnClickedEnableproxy()
{
	SetModified(true);
	UpdateData(TRUE);
		
	enableAuthCheck.EnableWindow(enableProxy);
	proxyTypeCombo.EnableWindow(enableProxy);
	proxyNameEdit.EnableWindow(enableProxy);
	proxyPortEdit.EnableWindow(enableProxy);
	userNameEdit.EnableWindow(enableProxy);
	passwordEdit.EnableWindow(enableProxy);
	if (enableProxy) {
		OnBnClickedEnableauth();
		OnCbnSelchangeProxytype();
		OnBnClickedAscwop();
	}
}

void CPPgProxy::OnBnClickedEnableauth()
{
	SetModified(true);
	UpdateData(TRUE);

	userNameEdit.EnableWindow(enableAuth);
	passwordEdit.EnableWindow(enableAuth);
}

void CPPgProxy::OnCbnSelchangeProxytype()
{
	SetModified(true);

	if (!(proxyTypeCombo.GetCurSel() == PROXYTYPE_SOCKS5 || proxyTypeCombo.GetCurSel() == PROXYTYPE_HTTP11))
	{
		enableAuth = false;
		UpdateData(TRUE);
		OnBnClickedEnableauth();
		enableAuthCheck.EnableWindow(false);
	} 
	else enableAuthCheck.EnableWindow(true);
}


void CPPgProxy::LoadSettings()
{
	serverConWoProxy = g_eMuleApp.m_pGlobPrefs->IsProxyASCWOP();
	enableProxy = proxy.m_bUseProxy;
	enableAuth = proxy.m_bEnablePassword;
	proxyTypeCombo.SetCurSel(proxy.m_nType);
	proxyName = proxy.m_strName;
	proxyPort.Format(_T("%ld"),proxy.m_uPort);
	proxyUser = proxy.m_strUser;
	proxyPassword = Decrypt(proxy.m_strPassword);
	UpdateData(FALSE);
	OnBnClickedEnableproxy();
}

void CPPgProxy::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_PROXY));
		enableProxyCheck.SetWindowText(GetResString(IDS_PROXY_ENABLED));	
		proxyTypeDesc = GetResString(IDS_PROXY_TYPE);	
		proxyNameDesc = GetResString(IDS_PROXY_ADDRESS);	
		proxyPortDesc = GetResString(IDS_PROXY_PORT);	
		enableAuthCheck.SetWindowText(GetResString(IDS_PROXY_AUTH_ENABLED));	
		userNameDesc = GetResString(IDS_PROXY_USERNAME);	
		passwordDesc = GetResString(IDS_PROXY_PASSWORD);	
		authDesc = GetResString(IDS_PROXY_AUTH);	
		serverConWoProxyCheck.SetWindowText(GetResString(IDS_SERVERCON_WO_PROXY));
		UpdateData(FALSE);
	}
}

void CPPgProxy::OnBnClickedAscwop()
{
	SetModified(true);
}
