//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include "types.h"
#include "titlemenu.h"
#include "MuleListCtrl.h"

#ifndef USRMSG_SWITCHUPLOADLIST
#define USRMSG_SWITCHUPLOADLIST	WM_USER + 12
#endif

enum EnumUploadListIcons
{
	UL_ICON_NORMAL = 0,
	UL_ICON_COMPROT,
	UL_ICON_MLDONKEY,
	UL_ICON_EDONKEYHYBRID,
	UL_ICON_CREDIT_ONLY,
	UL_ICON_FRIEND_ONLY,
	UL_ICON_BANNED_ONLY,
	UL_ICON_UNKNOWN,
	UL_ICON_CDONKEY,
	UL_ICON_LMULE,
	UL_ICON_SHAREAZA,
	UL_ICON_SECUREHASH,
};

enum EnumUploadListColumns
{
	ULCOL_USERNAME = 0,
	ULCOL_FILENAME,
	ULCOL_SPEED,
	ULCOL_TRANSFERRED,
	ULCOL_WAITED,
	ULCOL_UPLOADTIME,
	ULCOL_STATUS,
	ULCOL_PARTS,
	ULCOL_PROGRESS,
	ULCOL_COMPRESSION,

	ULCOL_NUMCOLUMNS,
};

// CUploadListCtrl
class CUpDownClient;

class CUploadListCtrl : public CMuleListCtrl
{
	DECLARE_DYNAMIC(CUploadListCtrl)

public:
	CUploadListCtrl();
	virtual ~CUploadListCtrl();
	void	Init();
	void	AddClient(CUpDownClient* client);
	void	RemoveClient(CUpDownClient* client);
	void	UpdateClient(CUpDownClient* client);
	void	Hide() {ShowWindow(SW_HIDE);}
	void	Show() {ShowWindow(SW_SHOW);}
	void	SortInit(int sortCode);
	void	Localize();
	virtual BOOL OnCommand(WPARAM wParam,LPARAM lParam );
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	CImageList m_imageList;

protected:
	static int CALLBACK SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	afx_msg	void OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnGetDispInfo(NMHDR* pNMHDR, LRESULT* pResult);

	virtual BOOL OnNMDividerDoubleClick(NMHEADER* pNMHDR, LRESULT* pResult);
	virtual BOOL OnWndMsg(UINT iMessage,WPARAM wParam, LPARAM lParam, LRESULT *pResult);

	DECLARE_MESSAGE_MAP()
private:
	bool			m_bSortAscending[ULCOL_NUMCOLUMNS];	 
	int				m_iColumnMaxWidths[ULCOL_NUMCOLUMNS];
	int				m_iMeasuringColumn;
public:
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnNMClick(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMDblclkUploadlist(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
private:	
	void RefreshInfo(void);
public:
	virtual BOOL OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
};


